Agents
Update an agent
POST
/agents/{agent_name}Updates the agent by adding a new version if there are any changes to the agent definition. If no changes, returns the existing agent version.
Path ParametersQuery ParametersHeader Parameters
agent_namestringrequired
The name of the agent to retrieve.api-versionstringrequired
The API version to use for this operation.Foundry-Featuresstringoptional
A feature flag opt-in required when using preview operations or modifying persisted preview resources.WorkflowAgents=V1PreviewExternalAgents=V1PreviewDraftAgents=V1PreviewVoiceAgents=V1PreviewDigitalWorker=V1Preview
x-ms-code-zip-sha256stringoptional
SHA-256 hex digest of the uploaded code zip. Used for change detection (dedup) and integrity verification.Request BodyThe content multipart request content.Content-Type: application/json
metadataobject
Set of 16 key-value pairs that can be attached to an object. This can be
useful for storing additional information about the object in a structured
format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings
with a maximum length of 512 characters.descriptionstring
A human-readable description of the agent.definitionhosted | prompt | workflow | externalrequired
One of the following:
hostedHostedAgentDefinition
The hosted agent definition.promptPromptAgentDefinition
The prompt agent definitionworkflowWorkflowAgentDefinition
The workflow agent definition. Microsoft Foundry is retiring workflows on December 1, 2026.
If you're looking to build new workflows, use Microsoft Agent Framework. To migrate existing workflows,
see the Migration guide.externalExternalAgentDefinition
The external agent definition. Represents a third-party agent hosted outside Foundry (for example, on GCP or AWS).
Registration is metadata-only: Foundry records the agent definition to light up observability experiences (traces, evaluations)
over customer-emitted OpenTelemetry data.blueprint_referenceManagedAgentIdentityBlueprint
One of the following:
ManagedAgentIdentityBlueprintManagedAgentIdentityBlueprintReference
Responses
objectenumrequired
The object type, which is always 'agent'.agent
idstringrequired
The unique identifier of the agent.namestringrequired
The name of the agent.stateenumrequired
The operational state of an agent.enableddisabled
state_sourceenum
Indicates the source of an agent's operational state. Empty when the state is not derived from a specific source.agent_instance_identityagent_blueprint
versionsobjectrequired
The latest version of the agent.latestAgentVersionObjectrequired
agent_endpointAgentEndpointConfig
version_selectorVersionSelector
protocol_configurationProtocolConfiguration
Per-protocol configuration for the agent endpoint.authorization_schemes(Entra | BotService | BotServiceRbac | BotServiceTenant)[]
The authorization schemes supported by the agent endpointpublish_approval_statusenum
The Microsoft Agent Certification review status of the Microsoft 365 store title published for an agent.not_publishedpendingapprovedrejectedno_approval_needed
digital_worker_typeenum
The type of digital worker.m365
instance_identityAgentIdentity
principal_idstringrequired
The principal ID of the agent instanceclient_idstringrequired
The client ID of the agent instance. Also referred to as the instance IDstatusenum
The status of an agent identity, applicable to both the agent instance identity and the agent blueprint.activedisabled
blueprintAgentIdentity
principal_idstringrequired
The principal ID of the agent instanceclient_idstringrequired
The client ID of the agent instance. Also referred to as the instance IDstatusenum
The status of an agent identity, applicable to both the agent instance identity and the agent blueprint.activedisabled
blueprint_referenceManagedAgentIdentityBlueprint
One of the following:
ManagedAgentIdentityBlueprintManagedAgentIdentityBlueprintReference
agent_cardAgentCard
versionstringrequired
The version of the agent card.descriptionstring
The description of the agent card.skillsAgentCardSkill[]required
The set of skills that an agent can perform.